"""
This script will provide the output form for an input form entered by the user. 
For the script to run it must be in the directory with the language subdirectories. 
In a terminal, navigate to the directory that contains the script and type 'python GetOutput.py' (not including the quotation marks). Then follow the instructions on screen.
"""

import sys

def ParseFile(f):
    delta = {}
    for l in f[:-1]:
        ll = l.split()
        delta[(ll[0],ll[2])] = (ll[3],ll[1])
    return delta

def GetOutput(s,d):
    output = ''
    state = '0'
    for i in s:
        next = d[(state,i)]
        if next[0] != '<eps>':
            output+=next[0]
        state = next[1]
    output+=d[(state,'#')][0]
    return output

def ValidInput(s,alpha):
    for c in s:
        if c not in alpha:
            return False
    return True

def SplitYowlumneWord(s):
    charlist = []
    i = 0
    while i < len(s):
       if i+1 == len(s):
           charlist.append(s[i])
           i+=1
       elif s[i+1] == ':':
           charlist.append(s[i:i+2])
           i+=2
       else:
           charlist.append(s[i])
           i+=1
    return charlist
          
def ui():
    choice = ''

    while choice != 'Q':
        choice = raw_input("Choose a language (1-7) or type Q to quit:\n1 Lithuanian\n2 Yowlumne\n3 Classical Arabic\n4 Tundra Nenets\n5 Bedouin Arabic (counterfeeding-on-environment)\n6 Bedouin Arabic (counterfeeding-on-focus)\n7 Turkish\n")
        
        if choice == '1':
            word = raw_input("The alphabet for Lithuanian is {C, V, p, b, t, d}. Enter an input string (or Ch to change languages):\n")
            while word != 'Ch':
                while not ValidInput(word,Lithalpha):
                    word = raw_input("Invalid input. The alphabet for Lithuanian is {C, V, p, b, t, d}). Enter an input string (or Ch to change languages):\n")
                    if word == 'Ch':
                        break
                if word == 'Ch':
                    break
                print 'The output for',word,'is',GetOutput(word,Lithdict)[:-1]
                word = raw_input("Enter another input (or Ch to change languages):\n")
                
        elif choice == '2':
            word = raw_input("The alphabet for Yowlumne is {C, V, i:, V:}. Enter an input string (or Ch to change languages):\n")
            while word != 'Ch':
                word = SplitYowlumneWord(word)
                while not ValidInput(word,Yowlumnealpha):
                    word = raw_input("Invalid input. The alphabet for Yowlumne is {C, V, i:, V:}). Enter an input string (or Ch to change languages):\n")
                    if word == 'Ch':
                        break
                    word = SplitYowlumneWord(word)
                if word == 'Ch':
                    break
                print 'The output for',''.join(word),'is',GetOutput(word,Yowlumnedict)[:-1]
                word = raw_input("Enter another input (or Ch to change languages):\n")
                
        elif choice == '3':
            word = raw_input("The alphabet for Classical Arabic is {C, V}. Enter an input string (or Ch to change languages):\n")
            while word != 'Ch':
                while not ValidInput(word,ClassicalArabicalpha):
                    word = raw_input("Invalid input. The alphabet for Classical Arabic is {C, V}). Enter an input string (or Ch to change languages):\n")
                    if word == 'Ch':
                        break
                if word == 'Ch':
                    break
                print 'The output for',word,'is',GetOutput('#'+word,ClassicalArabicdict)[:-1]
                word = raw_input("Enter another input (or Ch to change languages):\n")

        elif choice == '4':
            word = raw_input("The alphabet for Tundra Nenets is {C, V, T, ?, ^}. Enter an input string (or Ch to change languages):\n")
            while word != 'Ch':
                while not ValidInput(word,TundraNenetsalpha):
                    word = raw_input("Invalid input. The alphabet for Tundra Nenets is {C, V, T, ?, ^}). Enter an input string (or Ch to change languages):\n")
                    if word == 'Ch':
                        break
                if word == 'Ch':
                    break
                print 'The output for',word,'is',GetOutput(word,TundraNenetsdict)[:-1]
                word = raw_input("Enter another input (or Ch to change languages):\n")

        elif choice == '5':
            word = raw_input("The alphabet for Bedouin Arabic is {C, a, i, u, j, w}. Enter an input string (or Ch to change languages):\n")
            while word != 'Ch':
                while not ValidInput(word,BedouinArabic1alpha):
                    word = raw_input("Invalid input. The alphabet for Bedouin Arabic is {C, a, i, u, j, w}). Enter an input string (or Ch to change languages):\n")
                    if word == 'Ch':
                        break
                if word == 'Ch':
                    break
                print 'The output for',word,'is',GetOutput(word,BedouinArabic1dict)[:-1]
                word = raw_input("Enter another input (or Ch to change languages):\n")
                
        elif choice == '6':
            word = raw_input("The alphabet for Bedouin Arabic is {C, a, i, u}. Enter an input string (or Ch to change languages):\n")
            while word != 'Ch':
                while not ValidInput(word,BedouinArabic2alpha):
                    word = raw_input("Invalid input. The alphabet for Bedouin Arabic is {C, a, i, u}). Enter an input string (or Ch to change languages):\n")
                    if word == 'Ch':
                       break
                if word == 'Ch':
                    break
                print 'The output for',word,'is',GetOutput(word,BedouinArabic2dict)[:-1]
                word = raw_input("Enter another input (or Ch to change languages):\n")

        elif choice == '7':
            word = raw_input("The alphabet for Turkish is {C, V, K, +}. Enter an input string (or Ch to change languages):\n")
            while word != 'Ch':
                while not ValidInput(word,Turkishalpha):
                    word = raw_input("Invalid input. The alphabet for Turkish is {C, V, K, +}). Enter an input string (or Ch to change languages):\n")
                    if word == 'Ch':
                        break
                if word == 'Ch':
                    break
                print 'The output for',word,'is',GetOutput(word,Turkishdict)[:-1]
                word = raw_input("Enter another input (or Ch to change languages):\n")

        

        elif choice == 'Q':
            break

        else:
           choice = raw_input("Invalid choice. Choose a language (1-7) or type Q to quit:\n1 Lithuanian\n2 Yowlumne\n3 Classical Arabic\n4 Tundra Nenets\n5 Bedouin Arabic (counterfeeding-on-environment)\n 6 Bedouin Arabic (counterfeeding-on-focus)\n")            

        
        
try:            
    f1 = open('Lithuanian/trans-Lithuanian.fst','r')
    f2 = open('Yowlumne/trans-Yowlumne.fst','r')
    f3 = open('ClassicalArabic/trans-ClassicalArabic.fst','r')
    f4 = open('BedouinArabic1/trans-BedouinArabic1.fst','r')
    f5 = open('BedouinArabic2/trans-BedouinArabic2.fst','r')
    f6 = open('TundraNenets/trans-TundraNenets.fst','r')
    f7 = open('Turkish/trans-Turkish.fst','r')

except:
    print "This script must be run from a directory that contains the following files: Lithuanian/trans-Lithuanian.fst, Yowlumne/trans-Yowlumne.fst, ClassicalArabic/trans-ClassicalArabic.fst, BedouinArabic1/trans-BedouinArabic1.fst, BedouinArabic2/trans-BedouinArabic2.fst, TundraNenets/trans-TundraNenets.fst, Turkish/trans-Turkish.fst'"
    sys.exit(1)


f1_lines = f1.read().splitlines()
Lithdict=ParseFile(f1_lines)
Lithalpha = ['C','V','p','b','t','d']

f2 = open('Yowlumne/trans-Yowlumne.fst','r')
f2_lines = f2.read().splitlines()
Yowlumnedict=ParseFile(f2_lines)
Yowlumnealpha = ['C','V','i:','V:']

f3_lines = f3.read().splitlines()
ClassicalArabicdict=ParseFile(f3_lines)
ClassicalArabicalpha = ['C','V']

f4_lines = f4.read().splitlines()
BedouinArabic1dict=ParseFile(f4_lines)
BedouinArabic1alpha = ['C','a','u','i','j','w']

f5_lines = f5.read().splitlines()
BedouinArabic2dict=ParseFile(f5_lines)
BedouinArabic2alpha = ['C','a','u','i']

f6_lines = f6.read().splitlines()
TundraNenetsdict=ParseFile(f6_lines)
TundraNenetsalpha = ['C','V','?','^','T']

f7_lines = f7.read().splitlines()
Turkishdict=ParseFile(f7_lines)
Turkishalpha = ['C','V','K','+']


ui()

f1.close()
f2.close()
f3.close()
f4.close()
f5.close()
f6.close()
f7.close()


